/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOADING

#include "resource.h"

ObjectListDefinition(Resource);


/**
 * standard constructor
*/
Resource::Resource ()
    : _pointer(NULL)
{
  this->registerObject(this, Resource::_objectList);

}

/**
 * standard deconstructor
 */
Resource::~Resource ()
{
  // delete what has to be deleted here
}



Resource::Pointer* Resource::acquireResource(Resource::Type& resourceType, const std::string& loadString)
{
  if(resourceType.id() == -1)
  {
    Resource::_resourceTypes.push_back(&resourceType);
    resourceType.setID(Resource::_resourceTypes.size());
  }
  const Resource::Type* const type = Resource::_resourceTypes[resourceType.id()];

  for (unsigned int i = 0; i < type->storedResources().size(); ++i)
    if (type->storedResources()[i]->_pointer->loadString() == loadString)
      return type->storedResources()[i]->_pointer;

  return NULL;
}






void Resource::KeepLevel::setKeepLevelName(unsigned int level, const std::string& name)
{
  if (_keepLevelName.size() <= level)
    _keepLevelName.resize(level+1);
  _keepLevelName[level] = name;
}
